# Tests by default. No tests: rpm -ba --define 'dotests 0' gcc*.spec
%{!?dotests:%define DO_TESTS 1}
%{?dotests:%define DO_TESTS 0}

%define DO_OBJC 0
%define _bindir1 /opt/freeware/gcc7/bin
%define _libdir1 /opt/freeware/gcc7/lib
%define _libexecdir1 /opt/freeware/gcc7/libexec
%define _infodir1 /opt/freeware/gcc7/share/info
%define _mandir1 /opt/freeware/gcc7/share/man
%define _libdir641 /opt/freeware/gcc7/lib64
%define _datadir1 /opt/freeware/gcc7/share

Summary: GNU Compiler Collection
Name: gcc7
Version: 7.2.0
Release: 1
Group: Development/Tools
License: GPL
URL: http://gcc.gnu.org/
Source0: ftp://ftp.gnu.org/gnu/%{name}/gcc-%{version}/gcc-%{version}.tar.bz2
Source1: %{name}-BSum.1.0.sh
Source2: %{name}-BCmp.1.0.sh
Source3: %{name}-BCmpErr.1.0.sh


Patch0: gcc-%{version}-oslevel.patch
Patch1: gcc-%{version}-static-link-collect2.patch

# Unless you have a lot of space in /var/tmp, you will probably need to
# specify --buildroot on the command line to point to a larger filesystem.
BuildRoot: /opt/tmp/%{name}-%{version}-root

BuildRequires: bash, sed, automake, autoconf, texinfo, make, gcc
BuildRequires: gmp-devel >= 4.3.2, mpfr-devel >= 2.4.2, libmpc-devel >= 0.8.1
BuildRequires: zlib-devel >= 1.2.3-3
Requires: info
Prereq: /sbin/install-info
Requires: libgcc7 = %{version}-%{release}
Requires: gcc7-cpp = %{version}-%{release}
Conflicts: g++ <= 2.9.aix51.020209-4

%ifos aix6.1
%define buildhost powerpc-ibm-aix6.1.0.0
Requires: AIX-rpm >= 6.1.0.0
Requires: AIX-rpm <  6.2.0.0
%endif
%ifos aix7.1
%define buildhost powerpc-ibm-aix7.1.0.0
Requires: AIX-rpm >= 7.1.0.0
Requires: AIX-rpm <  7.2.0.0
%endif
%ifos aix7.2
%define buildhost powerpc-ibm-aix7.2.0.0
Requires: AIX-rpm >= 7.2.0.0
Requires: AIX-rpm <  7.3.0.0
%endif


%define _libdir64 %{_prefix}/lib64
%define gcclibexecdir /opt/freeware/gcc7/libexec/gcc/%{buildhost}/%{version}

%description
The gcc package contains the GNU Compiler Collection version %{version}.
You'll need this package in order to compile C code.


%package c++
Summary: C++ support for GCC
Group: Development/Languages
Requires: %{name} = %{version}-%{release}
Requires: libstdc++7-devel = %{version}-%{release}
Requires: gmp >= 4.3.2, mpfr >= 2.4.2, libmpc >= 0.8.1
Requires: zlib >= 1.2.3-3
Obsoletes: g++
%ifos aix6.1
Requires: AIX-rpm >= 6.1.0.0
Requires: AIX-rpm <  6.2.0.0
%endif
%ifos aix7.1
Requires: AIX-rpm >= 7.1.0.0
Requires: AIX-rpm <  7.2.0.0
%endif
%ifos aix7.2
Requires: AIX-rpm >= 7.2.0.0
Requires: AIX-rpm <  7.3.0.0
%endif

%description c++
This package adds C++ support to the GNU Compiler Collection.
It includes support for most of the current C++ specification,
including templates and exception handling.


%package cpp
Summary: The C Preprocessor
Group: Development/Languages
Requires: %{name} = %{version}-%{release}
Requires: gmp >= 4.3.2, mpfr >= 2.4.2, libmpc >= 0.8.1
Requires: zlib >= 1.2.3-3
%ifos aix6.1
Requires: AIX-rpm >= 6.1.0.0
Requires: AIX-rpm <  6.2.0.0
%endif
%ifos aix7.1
Requires: AIX-rpm >= 7.1.0.0
Requires: AIX-rpm <  7.2.0.0
%endif
%ifos aix7.2
Requires: AIX-rpm >= 7.2.0.0
Requires: AIX-rpm <  7.3.0.0
%endif

%description cpp
Cpp is the GNU C-Compatible Compiler Preprocessor.
Cpp is a macro processor which is used automatically
by the C compiler to transform your program before actual
compilation. It is called a macro processor because it allows
you to define macros, abbreviations for longer
constructs.

The C preprocessor provides four separate functionalities: the
inclusion of header files (files of declarations that can be
substituted into your program); macro expansion (you can define macros,
and the C preprocessor will replace the macros with their definitions
throughout the program); conditional compilation (using special
preprocessing directives, you can include or exclude parts of the
program according to various conditions); and line control (if you use
a program to combine or rearrange source files into an intermediate
file which is then compiled, you can use line control to inform the
compiler about where each source line originated).

You should install this package if you are a C programmer and you use
macros.


%package -n libgcc7
Summary: GCC version %{version} shared support library
Group: Development/Libraries
%ifos aix6.1
Requires: AIX-rpm >= 6.1.0.0
Requires: AIX-rpm <  6.2.0.0
%endif
%ifos aix7.1
Requires: AIX-rpm >= 7.1.0.0
Requires: AIX-rpm <  7.2.0.0
%endif
%ifos aix7.2
Requires: AIX-rpm >= 7.2.0.0
Requires: AIX-rpm <  7.3.0.0
%endif

%description -n libgcc7
This package contains GCC shared support library which is needed
e.g. for exception handling support.


%package -n libstdc++7
Summary: GNU Standard C++ Library
Group: Development/Libraries
Requires: libgcc7 = %{version}-%{release}
%ifos aix6.1
Requires: AIX-rpm >= 6.1.0.0
Requires: AIX-rpm <  6.2.0.0
%endif
%ifos aix7.1
Requires: AIX-rpm >= 7.1.0.0
Requires: AIX-rpm <  7.2.0.0
%endif
%ifos aix7.2
Requires: AIX-rpm >= 7.2.0.0
Requires: AIX-rpm <  7.3.0.0
%endif

%description -n libstdc++7
The libstdc++ package contains a rewritten standard compliant GCC Standard
C++ Library.


%package -n libstdc++7-devel
Summary: Header files and libraries for C++ development
Group: Development/Libraries
Requires: libstdc++7 = %{version}-%{release}
%ifos aix6.1
Requires: AIX-rpm >= 6.1.0.0
Requires: AIX-rpm <  6.2.0.0
%endif
%ifos aix7.1
Requires: AIX-rpm >= 7.1.0.0
Requires: AIX-rpm <  7.2.0.0
%endif
%ifos aix7.2
Requires: AIX-rpm >= 7.2.0.0
Requires: AIX-rpm <  7.3.0.0
%endif

%description -n libstdc++7-devel
This is the GNU implementation of the standard C++ libraries.  This
package includes the header files and libraries needed for C++
development. This includes a rewritten implementation of STL.


%package gfortran
Summary: Fortran 95 support
Group: Development/Languages
Requires: %{name} = %{version}-%{release}
Requires: gmp >= 4.3.2, mpfr >= 2.4.2, libmpc >= 0.8.1
Requires: zlib >= 1.2.3-3
%ifos aix6.1
Requires: AIX-rpm >= 6.1.0.0
Requires: AIX-rpm <  6.2.0.0
%endif
%ifos aix7.1
Requires: AIX-rpm >= 7.1.0.0
Requires: AIX-rpm <  7.2.0.0
%endif
%ifos aix7.2
Requires: AIX-rpm >= 7.2.0.0
Requires: AIX-rpm <  7.3.0.0
%endif

%description gfortran
The gcc-gfortran package provides support for compiling Fortran 95
programs with the GNU Compiler Collection.


%package -n libgomp7
Summary: GCC OpenMP 2.5 shared support library
Group: Development/Languages
Requires: %{name} = %{version}-%{release}
%ifos aix6.1
Requires: AIX-rpm >= 6.1.0.0
Requires: AIX-rpm <  6.2.0.0
%endif
%ifos aix7.1
Requires: AIX-rpm >= 7.1.0.0
Requires: AIX-rpm <  7.2.0.0
%endif
%ifos aix7.2
Requires: AIX-rpm >= 7.2.0.0
Requires: AIX-rpm <  7.3.0.0
%endif

%description -n libgomp7
This package contains GCC shared support library which is needed
for OpenMP 2.5 support.


if [ "%{DO_OBJC}" == 1 ]
then

Work in Progress

%package objc
Summary: Objective-C support for GCC
Group: Development/Languages
Requires: %{name} = %{version}-%{release}
Requires: libobjc = %{version}-%{release}
%ifos aix6.1
Requires: AIX-rpm >= 6.1.0.0
Requires: AIX-rpm <  6.2.0.0
%endif
%ifos aix7.1
Requires: AIX-rpm >= 7.1.0.0
Requires: AIX-rpm <  7.2.0.0
%endif
%ifos aix7.2
Requires: AIX-rpm >= 7.2.0.0
Requires: AIX-rpm <  7.3.0.0
%endif

%description objc
gcc-objc provides Objective-C support for the GCC.
Mainly used on systems running NeXTSTEP, Objective-C is an
object-oriented derivative of the C language.

%package objc++
Summary: Objective-C++ support for GCC
Group: Development/Languages
Requires: gcc-c++  = %{version}-%{release}
Requires: gcc-objc = %{version}-%{release}
Autoreq: true
%ifos aix6.1
Requires: AIX-rpm >= 6.1.0.0
Requires: AIX-rpm <  6.2.0.0
%endif
%ifos aix7.1
Requires: AIX-rpm >= 7.1.0.0
Requires: AIX-rpm <  7.2.0.0
%endif
%ifos aix7.2
Requires: AIX-rpm >= 7.2.0.0
Requires: AIX-rpm <  7.3.0.0
%endif

%description objc++
gcc-objc++ package provides Objective-C++ support for the GCC.

%package -n libobjc
Summary: Objective-C runtime
Group: System Environment/Libraries
Autoreq: true
%ifos aix6.1
Requires: AIX-rpm >= 6.1.0.0
Requires: AIX-rpm <  6.2.0.0
%endif
%ifos aix7.1
Requires: AIX-rpm >= 7.1.0.0
Requires: AIX-rpm <  7.2.0.0
%endif
%ifos aix7.2
Requires: AIX-rpm >= 7.2.0.0
Requires: AIX-rpm <  7.3.0.0
%endif

%description -n libobjc
This package contains Objective-C shared library which is needed to run
Objective-C dynamically linked programs.

fi


%prep
export PATH=/opt/freeware/bin:$PATH
%setup -q
%ifos aix5.1
%patch1
%endif
%ifos aix5.2
%patch2
%endif
%patch0 -p1 -b .oslevel
%patch1 -p1 -b .static_link

%build
export PATH=/usr/bin:/usr/sbin:/sbin:/opt/freeware/bin
export LDFLAGS="-Wl,-blibpath:/opt/freeware/lib64:/opt/freeware/lib:/opt/freeware/lib:/opt/freeware/lib/gcc/powerpc-ibm-aix6.1.0.0/6.3.0/ppc64:/opt/freeware/lib/gcc/powerpc-ibm-aix6.1.0.0/6.3.0:/opt/freeware/lib/gcc/powerpc-ibm-aix6.1.0.0/6.3.0/../../..:/usr/lib:/lib"

# speed up the configure processes...
export CONFIG_SHELL=/opt/freeware/bin/bash
export CONFIGURE_ENV_ARGS=/opt/freeware/bin/bash

# work around strange libtool error, see details at:
# https://www.ibm.com/developerworks/forums/thread.jspa?messageID=14145662
export RM="/usr/bin/rm -f"

export AR="/usr/bin/ar "


# use maximum amount of memory (heap) available to 32-bit programs 
# seems not to be taken into account though
export LDR_CNTRL=MAXDATA=0x80000000

cd ..
rm -rf gcc7-build-%{version}
mkdir gcc7-build-%{version}
cd gcc7-build-%{version}

/opt/freeware/bin/gcc --version

CC=/opt/freeware/bin/gcc				\
CXX=/opt/freeware/bin/g++				\
../%{name}-%{version}/configure 			\
	--prefix=/opt/freeware/gcc7				\
	--with-local-prefix=/opt/freeware		\
	--with-as=/usr/bin/as				\
	--with-ld=/usr/bin/ld				\
	--enable-languages="c,c++,fortran,objc,obj-c++"	\
	--enable-version-specific-runtime-libs		\
	--disable-nls 					\
	--enable-decimal-float=dpd			\
	--with-cloog=no					\
	--with-ppl=no					\
	--disable-libstdcxx-pch				\
	--enable-__cxa_atexit				\
	--host=%{buildhost}


export CC=/opt/freeware/bin/gcc
export CXX=/opt/freeware/bin/g++
export BOOT_CFLAGS='-O2 '

ulimit -d unlimited
ulimit -s unlimited


# Takes about 82mn on AIX 7.2 with 2 CPUs

gmake 						        \
	BOOT_CFLAGS='-O2 '				\
	CFLAGS='-O2 '					\
	CXXFLAGS='-O2 '					\
	LIBCFLAGS='-O2 '				\
	LIBCXXFLAGS='-O2 -fno-implicit-templates'


# >= 600mn on P8 2CPUs

if [ "%{DO_TESTS}" == 1 ]
then
    (gmake -k check || true)

    cd %{buildhost}

# Already done in previous gmake check ?!!
#      cd libatomic
#      (gmake -k check || true)
#      cd ..

#      cd libgomp
#      (gmake -k check || true)
#      cd ..

      cd ppc64

        cd libatomic
        (gmake -k check || true)
        cd ..

        cd libgomp
        (gmake -k check || true)
        cd ..

        cd libstdc++-v3
        (gmake -k check || true)
        cd ..
      cd ..

      cd pthread

        cd libatomic
        (gmake -k check || true)
        cd ..

        cd libgomp
        (gmake -k check || true)
        cd ..

        cd libstdc++-v3
        (gmake -k check || true)
        cd ..

        cd ppc64

          cd libatomic
          (gmake -k check || true)
          cd ..

          cd libgomp
          (gmake -k check || true)
          cd ..

          cd libstdc++-v3
          (gmake -k check || true)
          cd ..

        cd ..

      cd ..

    cd ..

    /usr/sbin/slibclean

fi
# END of tests


# remove the "-print-multi-os-directory" flag...
sed -e "s/MULTIOSDIR = \`\$(CC) \$(LIBCFLAGS) -print-multi-os-directory\`/MULTIOSDIR = ./" libiberty/Makefile > Makefile.tmp
mv -f Makefile.tmp libiberty/Makefile

echo "RPM_BUILD_ROOT: " ${RPM_BUILD_ROOT}


%install

# work around strange libtool error, see details at:
# https://www.ibm.com/developerworks/forums/thread.jspa?messageID=14145662
export RM="/usr/bin/rm -f"

export AR="/usr/bin/ar "


echo "RPM_BUILD_ROOT: " ${RPM_BUILD_ROOT}

[ "${RPM_BUILD_ROOT}" != "/" ] && rm -rf ${RPM_BUILD_ROOT}
cd ../gcc7-build-7.2.0
gmake install DESTDIR=${RPM_BUILD_ROOT}

cp %{_builddir}/gcc7-%{version}/gcc/doc/cpp*.info ${RPM_BUILD_ROOT}/opt/freeware/gcc7/share/info
cp %{_builddir}/gcc7-%{version}/gcc/doc/gcc*.info ${RPM_BUILD_ROOT}/opt/freeware/gcc7/share/info
cp %{_builddir}/gcc7-%{version}/gcc/fortran/*.info ${RPM_BUILD_ROOT}/opt/freeware/gcc7/share/info

# strip compiler binaries
strip ${RPM_BUILD_ROOT}/opt/freeware/gcc7/bin/* 2>/dev/null || :
for file in cc1 cc1plus collect2 f951 lto-wrapper ; do
    strip ${RPM_BUILD_ROOT}%{gcclibexecdir}/$file 2>/dev/null || :
done

# strip utilities
strip ${RPM_BUILD_ROOT}%{gcclibexecdir}/install-tools/fixincl 2>/dev/null || :
strip ${RPM_BUILD_ROOT}/opt/freeware/gcc7/lib/gcc/%{buildhost}/%{version}/install-tools/fixincl 2>/dev/null || :

# remove unrelated man pages
rm -rf ${RPM_BUILD_ROOT}/opt/freeware/gcc7/share/man/man7

# remove libiberty.a library which is not used directly by gcc
rm -f ${RPM_BUILD_ROOT}/opt/freeware/gcc7/lib/libiberty.a
for dir in power powerpc ppc64 pthread; do
    rm -rf ${RPM_BUILD_ROOT}%{_libdir1}/$dir
done

# remove empty include directory
rmdir ${RPM_BUILD_ROOT}/opt/freeware/gcc7/include || :

# gzip info pages
gzip --best ${RPM_BUILD_ROOT}/opt/freeware/gcc7/share/info/*.info

# patch 32-bit binaries to use the maximum number of 8 x 256MB data segments
# as the "export LDR_CNTRL=MAXDATA=0x80000000" setting seems not to be taken
# into account though
for f in ${RPM_BUILD_ROOT}/opt/freeware/gcc7/bin/* ; do
    if [[ "`/usr/bin/file ${f} | awk '{ print $2 }'`" = "executable" ]] ; then
        /usr/bin/echo '\0200\0\0\0' | /usr/bin/dd of=${f} bs=4 count=1 seek=19 conv=notrunc
    fi
done


# strip debugging information of all libraries as the settings specified
# while bootstrapping do not seem to be taken into account
(
    cd ${RPM_BUILD_ROOT}

    for f in `find . -name "*.a"` ; do
        if [ -f ${f} ] ; then
            /usr/bin/strip -X32_64 ${f}
        fi
    done
)


# Add 64bit .so from 64bit libX.a to 32bit libX.a
# For X = atomic gcc_s stdc++ supc++ gomp gfortran caf_single
mkdir /tmp/gcc-$$
(
    cd    /tmp/gcc-$$

    for lib in atomic gcc_s stdc++ supc++ gomp gfortran caf_single
    do
        rm -f *
        $AR -X64 xv ${RPM_BUILD_ROOT}/opt/freeware/gcc7/lib/gcc/%{buildhost}/%{version}/ppc64/lib$lib.a
        $AR -X64 -q ${RPM_BUILD_ROOT}/opt/freeware/gcc7/lib/gcc/%{buildhost}/%{version}/lib$lib.a *
        (  
          rm -f     ${RPM_BUILD_ROOT}/opt/freeware/gcc7/lib/gcc/%{buildhost}/%{version}/ppc64/lib$lib.a
          cd        ${RPM_BUILD_ROOT}/opt/freeware/gcc7/lib/gcc/%{buildhost}/%{version}/ppc64
          ln -s                      /opt/freeware/gcc7/lib/gcc/%{buildhost}/%{version}/lib$lib.a .
	)

        rm -f *
        $AR -X64 xv ${RPM_BUILD_ROOT}/opt/freeware/gcc7/lib/gcc/%{buildhost}/%{version}/pthread/ppc64/lib$lib.a
        $AR -X64 -q ${RPM_BUILD_ROOT}/opt/freeware/gcc7/lib/gcc/%{buildhost}/%{version}/pthread/lib$lib.a *
        (
          rm -f     ${RPM_BUILD_ROOT}/opt/freeware/gcc7/lib/gcc/%{buildhost}/%{version}/pthread/ppc64/lib$lib.a
          cd        ${RPM_BUILD_ROOT}/opt/freeware/gcc7/lib/gcc/%{buildhost}/%{version}/pthread/ppc64
          ln -s                      /opt/freeware/gcc7/lib/gcc/%{buildhost}/%{version}/pthread/lib$lib.a .
	)
    done
)
rm -rf /tmp/gcc-$$

# Add compatibility symbolic links
(
    mkdir -p ${RPM_BUILD_ROOT}%{_libdir1}
    cd ${RPM_BUILD_ROOT}%{_libdir1}
    ln -sf gcc/%{buildhost}/%{version}/libatomic.a .
    ln -sf gcc/%{buildhost}/%{version}/libgcc_s.a .
    ln -sf gcc/%{buildhost}/%{version}/libgfortran.a .
    ln -sf gcc/%{buildhost}/%{version}/libgomp.a .
    ln -sf gcc/%{buildhost}/%{version}/libstdc++.a .

    mkdir -p ${RPM_BUILD_ROOT}%{_libdir641}
    cd ${RPM_BUILD_ROOT}%{_libdir641}
    ln -sf ../lib/gcc/%{buildhost}/%{version}/ppc64/libatomic.a .
    ln -sf ../lib/gcc/%{buildhost}/%{version}/ppc64/libgcc_s.a .
    ln -sf ../lib/gcc/%{buildhost}/%{version}/ppc64/libgfortran.a .
    ln -sf ../lib/gcc/%{buildhost}/%{version}/ppc64/libgomp.a .
    ln -sf ../lib/gcc/%{buildhost}/%{version}/ppc64/libstdc++.a .

    mkdir -p ${RPM_BUILD_ROOT}%{_libdir1}/pthread
    cd ${RPM_BUILD_ROOT}%{_libdir1}/pthread
    ln -sf ../gcc/%{buildhost}/%{version}/pthread/libatomic.a .
    ln -sf ../gcc/%{buildhost}/%{version}/pthread/libgcc_s.a .
    ln -sf ../gcc/%{buildhost}/%{version}/pthread/libgfortran.a .
    ln -sf ../gcc/%{buildhost}/%{version}/pthread/libgomp.a .
    ln -sf ../gcc/%{buildhost}/%{version}/pthread/libstdc++.a .

    mkdir -p ${RPM_BUILD_ROOT}%{_libdir1}/pthread/ppc64
    cd ${RPM_BUILD_ROOT}%{_libdir1}/pthread/ppc64
    ln -sf ../../gcc/%{buildhost}/%{version}/pthread/ppc64/libatomic.a .
    ln -sf ../../gcc/%{buildhost}/%{version}/pthread/ppc64/libgcc_s.a .
    ln -sf ../../gcc/%{buildhost}/%{version}/pthread/ppc64/libgfortran.a .
    ln -sf ../../gcc/%{buildhost}/%{version}/pthread/ppc64/libgomp.a .
    ln -sf ../../gcc/%{buildhost}/%{version}/pthread/ppc64/libstdc++.a .
)


%post 
/sbin/install-info %{_infodir1}/gcc.info.gz %{_infodir1}/dir || :
/sbin/install-info %{_infodir1}/gccinstall.info.gz %{_infodir1}/dir || :
/sbin/install-info %{_infodir1}/gccint.info.gz %{_infodir1}/dir || :

%post -n libgomp7
/sbin/install-info %{_infodir1}/libgomp.info.gz %{_infodir1}/dir || :

%post cpp
/sbin/install-info %{_infodir1}/cpp.info.gz %{_infodir1}/dir || :
/sbin/install-info %{_infodir1}/cppinternals.info.gz %{_infodir1}/dir || :

%post gfortran
/sbin/install-info %{_infodir1}/gfortran.info.gz %{_infodir1}/dir || :


%preun
if [ "$1" = 0 ]; then
    /sbin/install-info --delete %{_infodir1}/gcc.info.gz %{_infodir1}/dir || :
    /sbin/install-info --delete %{_infodir1}/gccinstall.info.gz %{_infodir1}/dir || :
    /sbin/install-info --delete %{_infodir1}/gccint.info.gz %{_infodir1}/dir || :
fi

%preun -n libgomp7
if [ "$1" = 0 ]; then
    /sbin/install-info --delete %{_infodir1}/libgomp.info.gz %{_infodir1}/dir || :
fi

%preun cpp
if [ "$1" = 0 ]; then
    /sbin/install-info --delete %{_infodir1}/cpp.info.gz %{_infodir1}/dir || :
    /sbin/install-info --delete %{_infodir1}/cppinternals.info.gz %{_infodir1}/dir || :
fi

%preun gfortran
if [ "$1" = 0 ]; then
    /sbin/install-info --delete %{_infodir1}/gfortran.info.gz %{_infodir1}/dir || :
fi


%clean
###[ "${RPM_BUILD_ROOT}" != "/" ] && rm -rf ${RPM_BUILD_ROOT}


%files
%defattr(-,root,system)
%{_bindir1}/gcc
%{_bindir1}/gcov
%{_bindir1}/gcc-ar
%{_bindir1}/gcc-nm
%{_bindir1}/gcc-ranlib
%{_bindir1}/%{buildhost}-gcc
%{_bindir1}/%{buildhost}-gcc-%{version}
%{_bindir1}/%{buildhost}-gcc-ar
%{_bindir1}/%{buildhost}-gcc-nm
%{_bindir1}/%{buildhost}-gcc-ranlib
%dir %{_libdir1}/gcc
%dir %{_libdir1}/gcc/%{buildhost}
%dir %{_libdir1}/gcc/%{buildhost}/%{version}
%dir %{_libdir1}/gcc/%{buildhost}/%{version}/ppc64
%dir %{_libdir1}/gcc/%{buildhost}/%{version}/pthread
%dir %{_libdir1}/gcc/%{buildhost}/%{version}/pthread/ppc64
%{_libdir1}/gcc/%{buildhost}/%{version}/crtcxa*o
%{_libdir1}/gcc/%{buildhost}/%{version}/crtdbase.o
%{_libdir1}/gcc/%{buildhost}/%{version}/libgcc.a
%{_libdir1}/gcc/%{buildhost}/%{version}/libgcc_eh.a
%{_libdir1}/gcc/%{buildhost}/%{version}/libgcov.a
%{_libdir1}/gcc/%{buildhost}/%{version}/ppc64/crtcxa*o
%{_libdir1}/gcc/%{buildhost}/%{version}/ppc64/crtdbase.o
%{_libdir1}/gcc/%{buildhost}/%{version}/ppc64/libgcc.a
%{_libdir1}/gcc/%{buildhost}/%{version}/ppc64/libgcc_eh.a
%{_libdir1}/gcc/%{buildhost}/%{version}/ppc64/libgcov.a
%{_libdir1}/gcc/%{buildhost}/%{version}/pthread/crtcxa*o
%{_libdir1}/gcc/%{buildhost}/%{version}/pthread/crtdbase.o
%{_libdir1}/gcc/%{buildhost}/%{version}/pthread/libgcc.a
%{_libdir1}/gcc/%{buildhost}/%{version}/pthread/libgcc_eh.a
%{_libdir1}/gcc/%{buildhost}/%{version}/pthread/libgcov.a
%{_libdir1}/gcc/%{buildhost}/%{version}/pthread/ppc64/crtcxa*o
%{_libdir1}/gcc/%{buildhost}/%{version}/pthread/ppc64/crtdbase.o
%{_libdir1}/gcc/%{buildhost}/%{version}/pthread/ppc64/libgcc.a
%{_libdir1}/gcc/%{buildhost}/%{version}/pthread/ppc64/libgcc_eh.a
%{_libdir1}/gcc/%{buildhost}/%{version}/pthread/ppc64/libgcov.a

%{_libexecdir1}/gcc/%{buildhost}/%{version}/collect2
%{_libexecdir1}/gcc/%{buildhost}/%{version}/lto-wrapper
%{_libexecdir1}/gcc/%{buildhost}/%{version}/install-tools

%dir %{_libdir1}/gcc/%{buildhost}/%{version}/include
%{_libdir1}/gcc/%{buildhost}/%{version}/include/[^c++]*
%{_libdir1}/gcc/%{buildhost}/%{version}/include-fixed

%{_libdir1}/gcc/%{buildhost}/%{version}/install-tools

%{_infodir1}/gcc*

%{_mandir1}/man1/gcc.1
%{_mandir1}/man1/gcov.1
%doc gcc/COPYING* MAINTAINERS gcc/README* 


%files cpp 
%dir %{_libexecdir1}/gcc
%dir %{_libexecdir1}/gcc/%{buildhost}
%dir %{_libexecdir1}/gcc/%{buildhost}/%{version}
%{_bindir1}/cpp
%{_libexecdir1}/gcc/%{buildhost}/%{version}/cc1
%{_mandir1}/man1/cpp.1
%{_infodir1}/cpp*


%files -n libgomp7
%{_libdir1}/gcc/%{buildhost}/%{version}/libgomp.a
%{_libdir1}/gcc/%{buildhost}/%{version}/libgomp.la
%{_libdir1}/gcc/%{buildhost}/%{version}/libgomp.spec
%{_libdir1}/gcc/%{buildhost}/%{version}/ppc64/libgomp.a
%{_libdir1}/gcc/%{buildhost}/%{version}/ppc64/libgomp.la
%{_libdir1}/gcc/%{buildhost}/%{version}/ppc64/libgomp.spec
%{_libdir1}/gcc/%{buildhost}/%{version}/pthread/libgomp.a
%{_libdir1}/gcc/%{buildhost}/%{version}/pthread/libgomp.la
%{_libdir1}/gcc/%{buildhost}/%{version}/pthread/libgomp.spec
%{_libdir1}/gcc/%{buildhost}/%{version}/pthread/ppc64/libgomp.a
%{_libdir1}/gcc/%{buildhost}/%{version}/pthread/ppc64/libgomp.la
%{_libdir1}/gcc/%{buildhost}/%{version}/pthread/ppc64/libgomp.spec
%{_libdir1}/libgomp.a
%{_libdir641}/libgomp.a
%{_libdir1}/pthread/libgomp.a
%{_libdir1}/pthread/ppc64/libgomp.a
%{_infodir1}/libgomp*


%files c++
%defattr(-,root,system)
%dir %{_libdir1}/gcc
%dir %{_libdir1}/gcc/%{buildhost}
%dir %{_libdir1}/gcc/%{buildhost}/%{version}
%dir %{_libdir1}/gcc/%{buildhost}/%{version}/ppc64
%dir %{_libdir1}/gcc/%{buildhost}/%{version}/pthread
%dir %{_libdir1}/gcc/%{buildhost}/%{version}/pthread/ppc64
%{_bindir1}/c++
%{_bindir1}/g++
%{_bindir1}/%{buildhost}-c++
%{_bindir1}/%{buildhost}-g++
%{_libexecdir1}/gcc/%{buildhost}/%{version}/cc1plus
%{_mandir1}/man1/g++.1
%doc gcc/COPYING*


%files -n libgcc7
%defattr(-,root,system)
%dir %{_libdir1}/gcc
%dir %{_libdir1}/gcc/%{buildhost}
%dir %{_libdir1}/gcc/%{buildhost}/%{version}
%dir %{_libdir1}/gcc/%{buildhost}/%{version}/ppc64
%dir %{_libdir1}/gcc/%{buildhost}/%{version}/pthread
%dir %{_libdir1}/gcc/%{buildhost}/%{version}/pthread/ppc64
%{_libdir1}/gcc/%{buildhost}/%{version}/libgcc_s.a
%{_libdir1}/gcc/%{buildhost}/%{version}/libatomic.*
%{_libdir1}/gcc/%{buildhost}/%{version}/ppc64/libgcc_s.a
%{_libdir1}/gcc/%{buildhost}/%{version}/ppc64/libatomic.*
%{_libdir1}/gcc/%{buildhost}/%{version}/pthread/libgcc_s.a
%{_libdir1}/gcc/%{buildhost}/%{version}/pthread/libatomic.*
%{_libdir1}/gcc/%{buildhost}/%{version}/pthread/ppc64/libgcc_s.a
%{_libdir1}/gcc/%{buildhost}/%{version}/pthread/ppc64/libatomic.*
%{_libdir1}/libgcc_s.a
%{_libdir1}/libatomic.a
%{_libdir641}/libgcc_s.a
%{_libdir641}/libatomic.a
%{_libdir1}/pthread/libgcc_s.a
%{_libdir1}/pthread/libatomic.a
%{_libdir1}/pthread/ppc64/libgcc_s.a
%{_libdir1}/pthread/ppc64/libatomic.a
%doc gcc/COPYING*


%files -n libstdc++7
%defattr(-,root,system)
%dir %{_libdir1}/gcc
%dir %{_libdir1}/gcc/%{buildhost}
%dir %{_libdir1}/gcc/%{buildhost}/%{version}
%dir %{_libdir1}/gcc/%{buildhost}/%{version}/ppc64
%dir %{_libdir1}/gcc/%{buildhost}/%{version}/pthread
%dir %{_libdir1}/gcc/%{buildhost}/%{version}/pthread/ppc64
%{_libdir1}/gcc/%{buildhost}/%{version}/libstdc++.a
%{_libdir1}/gcc/%{buildhost}/%{version}/ppc64/libstdc++.a
%{_libdir1}/gcc/%{buildhost}/%{version}/pthread/libstdc++.a
%{_libdir1}/gcc/%{buildhost}/%{version}/pthread/ppc64/libstdc++.a
%{_libdir1}/libstdc++.a
%{_libdir641}/libstdc++.a
%{_libdir1}/pthread/libstdc++.a
%{_libdir1}/pthread/ppc64/libstdc++.a
%{_libdir1}/gcc/%{buildhost}/%{version}/libstdc++.a-gdb.py
%{_libdir1}/gcc/%{buildhost}/%{version}/ppc64/libstdc++.a-gdb.py
%{_libdir1}/gcc/%{buildhost}/%{version}/pthread/libstdc++.a-gdb.py
%{_libdir1}/gcc/%{buildhost}/%{version}/pthread/ppc64/libstdc++.a-gdb.py
%dir %{_datadir1}/gcc-%{version}
%dir %{_datadir1}/gcc-%{version}/python
%{_datadir1}/gcc-%{version}/python/libstdcxx
%doc gcc/COPYING*


%files -n libstdc++7-devel
%defattr(-,root,system)
%dir %{_libdir1}/gcc
%dir %{_libdir1}/gcc/%{buildhost}
%dir %{_libdir1}/gcc/%{buildhost}/%{version}
%dir %{_libdir1}/gcc/%{buildhost}/%{version}/ppc64
%dir %{_libdir1}/gcc/%{buildhost}/%{version}/pthread
%dir %{_libdir1}/gcc/%{buildhost}/%{version}/pthread/ppc64
%{_libdir1}/gcc/%{buildhost}/%{version}/libstdc++.la
%{_libdir1}/gcc/%{buildhost}/%{version}/libsupc++.a
%{_libdir1}/gcc/%{buildhost}/%{version}/libsupc++.la
%{_libdir1}/gcc/%{buildhost}/%{version}/ppc64/libstdc++.la
%{_libdir1}/gcc/%{buildhost}/%{version}/ppc64/libsupc++.a
%{_libdir1}/gcc/%{buildhost}/%{version}/ppc64/libsupc++.la
%{_libdir1}/gcc/%{buildhost}/%{version}/pthread/libstdc++.la
%{_libdir1}/gcc/%{buildhost}/%{version}/pthread/libsupc++.a
%{_libdir1}/gcc/%{buildhost}/%{version}/pthread/libsupc++.la
%{_libdir1}/gcc/%{buildhost}/%{version}/pthread/ppc64/libstdc++.la
%{_libdir1}/gcc/%{buildhost}/%{version}/pthread/ppc64/libsupc++.a
%{_libdir1}/gcc/%{buildhost}/%{version}/pthread/ppc64/libsupc++.la
%{_libdir1}/gcc/%{buildhost}/%{version}/include/c++
%doc gcc/COPYING*


%files gfortran
%defattr(-,root,system)
%dir %{_libdir1}/gcc
%dir %{_libdir1}/gcc/%{buildhost}
%dir %{_libdir1}/gcc/%{buildhost}/%{version}
%dir %{_libdir1}/gcc/%{buildhost}/%{version}/ppc64
%dir %{_libdir1}/gcc/%{buildhost}/%{version}/pthread
%dir %{_libdir1}/gcc/%{buildhost}/%{version}/pthread/ppc64
%{_bindir1}/gfortran
%{_bindir1}/%{buildhost}-gfortran
%{_libdir1}/gcc/%{buildhost}/%{version}/finclude
%{_libdir1}/gcc/%{buildhost}/%{version}/libgfortran.a
%{_libdir1}/gcc/%{buildhost}/%{version}/libgfortran.la
%{_libdir1}/gcc/%{buildhost}/%{version}/libgfortran.spec
%{_libdir1}/gcc/%{buildhost}/%{version}/libcaf_single.a
%{_libdir1}/gcc/%{buildhost}/%{version}/libcaf_single.la
%{_libdir1}/gcc/%{buildhost}/%{version}/ppc64/libgfortran.a
%{_libdir1}/gcc/%{buildhost}/%{version}/ppc64/libgfortran.la
%{_libdir1}/gcc/%{buildhost}/%{version}/ppc64/libgfortran.spec
%{_libdir1}/gcc/%{buildhost}/%{version}/ppc64/libcaf_single.a
%{_libdir1}/gcc/%{buildhost}/%{version}/ppc64/libcaf_single.la
%{_libdir1}/gcc/%{buildhost}/%{version}/pthread/libgfortran.a
%{_libdir1}/gcc/%{buildhost}/%{version}/pthread/libgfortran.la
%{_libdir1}/gcc/%{buildhost}/%{version}/pthread/libgfortran.spec
%{_libdir1}/gcc/%{buildhost}/%{version}/pthread/libcaf_single.la
%{_libdir1}/gcc/%{buildhost}/%{version}/pthread/libcaf_single.a
%{_libdir1}/gcc/%{buildhost}/%{version}/pthread/ppc64/libgfortran.a
%{_libdir1}/gcc/%{buildhost}/%{version}/pthread/ppc64/libgfortran.la
%{_libdir1}/gcc/%{buildhost}/%{version}/pthread/ppc64/libgfortran.spec
%{_libdir1}/gcc/%{buildhost}/%{version}/pthread/ppc64/libcaf_single.a
%{_libdir1}/gcc/%{buildhost}/%{version}/pthread/ppc64/libcaf_single.la
%{_libdir1}/libgfortran.a
%{_libdir641}/libgfortran.a
%{_libdir1}/pthread/libgfortran.a
%{_libdir1}/pthread/ppc64/libgfortran.a
%{_libexecdir1}/gcc/%{buildhost}/%{version}/f951
%{_infodir1}/gfortran.info.gz
%{_mandir1}/man1/gfortran.1
%doc gcc/COPYING*



%changelog
* Fri Nov 01 2019 Nitish K Mishra <nitismis@in.ibm.com> - gcc7-7.2.0-1
- rebuild for multi version support

* Mon Sep 24 2018 Nitish K Mishra <nitismis@in.ibm.com> - 6.3.0-2
- Rebuild to include static linking issue patch. 

* Mon Jul 24 2017 Nitish Mishra <nitismis@in.ibm.com> - 6.3.0-1
- Initial port on AIX 7.2

* Tue Feb 03 2017 Tony Reix <tony.reix@bull.net> - 6.3.0-1
- Initial port on AIX 6.1

* Tue Aug 23 2016 Tony Reix <tony.reix@bull.net> - 6.2.0-1
- Initial port on AIX 6.1

* Thu Jun 09 2016 Tony Reix <tony.reix@bull.net> - 6.1.0-5
- Remove everything dealing with AIX 5.*
- Put all 32bit & 64bit .so files in ..../libX.a file for X=
     atomic gcc_s stdc++ supc++ gomp gfortran caf_single
- Replace 64bits libs by link to 32bits lib
- Port on AIX 6.1

* Mon May 30 2016 Tony Reix <tony.reix@bull.net> - 6.1.0-4
- Fix issues with Requires for libstdc++ and libstdc++-devel

* Wed May 25 2016 Tony Reix <tony.reix@bull.net> - 6.1.0-3
- Improve tests: tools and logs analysis

* Mon May 23 2016 Tony Reix <tony.reix@bull.net> - 6.1.0-2
- Initial port on AIX 7.2

* Tue Nov 05 2015 Tony Reix <tony.reix@bull.net> - 5.2.0-1
- Updated to version 5.2.0

* Tue Mar 10 2015 Gerard Visiedo <gerard.visiedo@bull.net> - 4.8.4-2
- Change gcc and g++ binairies paths to standard bindir

* Fri Feb 27 2015 Hamza Sellami BULL <hamzasell@gmail.com> - 4.8.4-1
- Porting GCC 4.8.4 to fixe some issues

* Fri May 23 2014 Michael Perzl <michael@perzl.org> - 4.8.3-1
- Updated to version 4.8.3.

* Thu Oct 17 2013 Michael Perzl <michael@perzl.org> - 4.8.2-1
- Updated to version 4.8.2.

* Fri May 31 2013 Michael Perzl <michael@perzl.org> - 4.8.1-1
- Updated to version 4.8.1.

* Tue Apr 30 2013 Michael Perzl <michael@perzl.org> - 4.8.0-2
- Added missing files/libraries introduced with version 4.8.0.
- Added libstdc++ Python support files.

* Sun Mar 24 2013 Michael Perzl <michael@perzl.org> - 4.8.0-1
- Updated to version 4.8.0.

* Wed Dec 05 2012 Michael Perzl <michael@perzl.org> - 4.7.2-2
- Fixed wrong gcc shared libraries compatibility symbolic links.

* Fri Sep 21 2012 Michael Perzl <michael@perzl.org> - 4.7.2-1
- Updated to version 4.7.2.
- Added the -fPIC patch from David Edelsohn <edelsohn@us.ibm.com>.

* Tue Aug 21 2012 Michael Perzl <michael@perzl.org> - 4.7.1-3
- Added the "AIX libgcc.map missing" patch from
  http://gcc.gnu.org/ml/gcc-patches/2012-08/msg01120.html.

* Thu Jun 14 2012 Michael Perzl <michael@perzl.org> - 4.7.1-2
- Added the libstdc++ patch for GCC bug 52887.
- Reorganized gcc shared libraries compatibility symbolic links.

* Thu Jun 14 2012 Michael Perzl <michael@perzl.org> - 4.7.1-1
- Updated to version 4.7.1.

* Thu Mar 22 2012 Michael Perzl <michael@perzl.org> - 4.7.0-1
- Updated to version 4.7.0.

* Tue Mar 13 2012 Michael Perzl <michael@perzl.org> - 4.6.3-2
- Added missing dependency on gcc-cpp for 'gcc'.

* Thu Mar 01 2012 Michael Perzl <michael@perzl.org> - 4.6.3-1
- Updated to version 4.6.3.

* Thu Oct 27 2011 Michael Perzl <michael@perzl.org> - 4.6.2-1
- Updated to version 4.6.2.

* Wed Jul 13 2011 Michael Perzl <michael@perzl.org> - 4.6.1-1
- Updated to version 4.6.1.

* Wed Jul 13 2011 Michael Perzl <michael@perzl.org> - 4.6.0-2
- Fixed dependencies on gmp, mpfr and libmpc for gcc-c++ and gcc-cpp packages.

* Sat Mar 26 2011 Michael Perzl <michael@perzl.org> - 4.6.0-1
- Updated to version 4.6.0.

* Sat Mar 26 2011 Michael Perzl <michael@perzl.org> - 4.5.2-2
- Fixed some small RPM SPEC file errors.

* Thu Mar 10 2011 Michael Perzl <michael@perzl.org> - 4.5.2-1
- Updated to version 4.5.2.

* Thu Nov 04 2010 Michael Perzl <michael@perzl.org> - 4.4.5-1
- Updated to version 4.4.5.

* Tue Jun 22 2010 Michael Perzl <michael@perzl.org> - 4.3.5-1
- Updated to version 4.3.5.

* Wed Mar 24 2010 Michael Perzl <michael@perzl.org> - 4.3.4-1
- Updated to version 4.3.4.

* Fri Dec 11 2009 Michael Perzl <michael@perzl.org> - 4.2.4-2
- fixed some spec file and portability issues.

* Sat May 31 2008 Michael Perzl <michael@perzl.org> - 4.2.4-1
- Updated to version 4.2.4.

* Tue Feb 19 2008 Michael Perzl <michael@perzl.org> - 4.2.3-1
- Updated to version 4.2.3.

* Thu Nov 29 2007 Michael Perzl <michael@perzl.org> - 4.2.2-1
- First version for AIX, slightly based on the original SPEC file from IBM.
